---
title: <input type="color">
slug: Web/HTML/Element/input/color
tags:
  - Color Picker
  - Element
  - Form input
  - Forms
  - HTML
  - HTML forms
  - HTML input
  - Input
  - Reference
  - color
---
<div>{{HTMLRef}}</div>

<p><span class="seoSummary">{{HTMLElement("input")}} elements of type <code><strong>color</strong></code> provide a user interface element that lets a user specify a color, either by using a visual color picker interface or by entering the color into a text field in <code>#rrggbb</code> hexadecimal format.</span> Only simple colors (without alpha channel) are allowed though CSS colors has more formats, e.g. color names, functional notations and a hexadecimal format with an alpha channel.</p>

<p>The element's presentation may vary substantially from one browser and/or platform to another—it might be a simple textual input that automatically validates to ensure that the color information is entered in the proper format, or a platform-standard color picker, or some kind of custom color picker window.</p>

<div>{{EmbedInteractiveExample("pages/tabbed/input-color.html", "tabbed-standard")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<table class="properties">
 <tbody>
  <tr>
   <td><strong>{{anch("Value")}}</strong></td>
   <td>A 7-character {{domxref("DOMString")}} specifying a {{cssxref("&lt;color&gt;")}} in lower-case hexadecimal notation</td>
  </tr>
  <tr>
   <td><strong>Events</strong></td>
   <td>{{domxref("HTMLElement/change_event", "change")}} and {{domxref("HTMLElement/input_event", "input")}}</td>
  </tr>
  <tr>
   <td><strong>Supported common attributes</strong></td>
   <td>{{htmlattrxref("autocomplete", "input")}} and {{htmlattrxref("list", "input")}}</td>
  </tr>
  <tr>
   <td><strong>IDL attributes</strong></td>
   <td><code>list</code> and <code>value</code></td>
  </tr>
  <tr>
   <td><strong>Methods</strong></td>
   <td>{{domxref("HTMLInputElement.select", "select()")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Value">Value</h2>

<p>The {{htmlattrxref("value", "input")}} of an {{HTMLElement("input")}} element of type <code>color</code> is always a {{domxref("DOMString")}} which contains a 7-character string specifying an RGB color in hexadecimal format. While you can input the color in either upper- or lower-case, it will be stored in lower-case form. The value is never in any other form, and is never empty.</p>

<div class="note">
<p><strong>Note</strong>: Setting the value to anything that isn't a valid, fully-opaque, RGB color <em>in hexadecimal notation</em> will result in the value being set to <code>#000000</code>. In particular, you can't use CSS's standardized color names, or any CSS function syntax, to set the value. This makes sense when you keep in mind that HTML and CSS are separate languages and specifications. In addition, colors with an alpha channel are not supported; specifying a color in 9-character hexadecimal notation (e.g. <code>#009900aa</code>) will also result in the color being set to <code>#000000</code>.</p>
</div>

<h2 id="Using_color_inputs">Using color inputs</h2>

<p>Inputs of type <code>color</code> are simple, due to the limited number of attributes they support.</p>

<h3 id="Providing_a_default_color">Providing a default color</h3>

<p>You can update the simple example above to set a default value, so that the color well is pre-filled with the default color and the color picker (if any) will also default to that color:</p>

<pre class="brush: html notranslate">&lt;input type="color" value="#ff0000"&gt;</pre>

<p>{{EmbedLiveSample("Providing_a_default_color", 700, 30)}}</p>

<p>If you don't specify a value, the default is <code>#000000</code>, which is black. The value must be in seven-character hexadecimal notation, meaning the "#" character followed by two digits each representing red, green, and blue, like this: <code>#rrggbb</code>. If you have colors that are in any other format (such as CSS color names or CSS color functions such as <code>rgb()</code> or <code>rgba()</code>), you'll have to convert them to hexadecimal before setting the <code>value</code>.</p>

<h3 id="Tracking_color_changes">Tracking color changes</h3>

<p>As is the case with other {{HTMLElement("input")}} types, there are two events that can be used to detect changes to the color value: {{domxref("HTMLElement/input_event", "input")}} and {{domxref("HTMLElement/change_event", "change")}}. <code>input</code> is fired on the <code>&lt;input&gt;</code> element every time the color changes. The <code>change</code> event is fired when the user dismisses the color picker. In both cases, you can determine the new value of the element by looking at its {{domxref("HTMLInputElement.value", "value")}}.</p>

<p>Here's an example that watches changes over time to the color value:</p>

<pre class="brush: js notranslate">colorPicker.addEventListener("input", updateFirst, false);
colorPicker.addEventListener("change", watchColorPicker, false);

function watchColorPicker(event) {
  document.querySelectorAll("p").forEach(function(p) {
    p.style.color = event.target.value;
  });
}
</pre>

<h3 id="Selecting_the_value">Selecting the value</h3>

<p>If the {{HTMLElement("input")}} element's implementation of the <code>color</code> type on the user's browser doesn't support a color well, but is instead a text field for entering the color string directly, you can use the {{domxref("HTMLInputElement.select", "select()")}} method to select the text currently in the edit field. If the browser instead uses a color well, <code>select()</code> does nothing. You should be aware of this behavior so your code can respond appropriately in either case.</p>

<pre class="brush: js notranslate">colorWell.select();</pre>

<h3 id="Appearance_variations">Appearance variations</h3>

<p>As previously mentioned, when a browser doesn't support a color picker interface, its implementation of color inputs will be a text box that validates the contents automatically to ensure that the value is in the correct format. For example, in Safari 10.1, you would see something that looks like this:</p>

<p><img alt="Screenshot of the example taken in Safari." src="input-color-safari.png" style="border-style: solid; border-width: 1px; height: 160px; width: 598px;"></p>

<p>The same content looks like this in Firefox 55:</p>

<p><img alt="Screenshot of the example taken in Firefox 55 for macOS" src="input-color-firefox.png" style="border-style: solid; border-width: 1px; height: 160px; width: 598px;"></p>

<p>In this case, clicking on the color well presents the platform's color picker for you to choose a color from (in this case, the macOS picker):</p>

<p><img alt="Screenshot of the element with the color picker open in Firefox Mac." src="input-with-picker-firefox-mac.png" style="border-style: solid; border-width: 1px; height: 405px; width: 682px;"></p>

<h2 id="Validation">Validation</h2>

<p>A color input's value is considered to be invalid if the {{Glossary("user agent")}} is unable to convert the user's input into seven-character lower-case hexadecimal notation. If and when this is the case, the {{cssxref(":invalid")}} pseudo-class is applied to the element.</p>

<h2 id="Example">Example</h2>

<p>Let's create an example which does a little more with the color input by tracking the {{domxref("HTMLElement/change_event", "change")}} and {{domxref("HTMLElement/input_event", "input")}} events to take the new color and apply it to every {{HTMLElement("p")}} element in the document.</p>

<h3 id="HTML">HTML</h3>

<p>The HTML is fairly straightforward — a couple of paragraphs of descriptive material with an {{HTMLElement("input")}} of type <code>color</code> with the ID <code>colorWell</code>, which we'll use to change the color of the paragraphs' text.</p>

<pre class="brush: html notranslate">&lt;p&gt;An example demonstrating the use of the &lt;code&gt;&amp;lt;input type="color"&amp;gt;&lt;/code&gt;
   control.&lt;/p&gt;

&lt;label for="colorWell"&gt;Color:&lt;/label&gt;
&lt;input type="color" value="#ff0000" id="colorWell"&gt;

&lt;p&gt;Watch the paragraph colors change when you adjust the color picker.
   As you make changes in the color picker, the first paragraph's
   color changes, as a preview (this uses the &lt;code&gt;input&lt;/code&gt;
   event). When you close the color picker, the &lt;code&gt;change&lt;/code&gt;
   event fires, and we detect that to change every paragraph to
   the selected color.&lt;/p&gt;</pre>

<h3 id="JavaScript">JavaScript</h3>

<p>First, there's some setup. Here we establish some variables, setting up a variable that contains the color we'll set the color well to when we first load up, and then setting up a {{domxref("Window/load_event", "load")}} handler to do the main startup work once the page is fully loaded.</p>

<pre class="brush: js notranslate">var colorWell;
var defaultColor = "#0000ff";

window.addEventListener("load", startup, false);
</pre>

<h4 id="Initialization">Initialization</h4>

<p>Once the page is loaded, our <code>load</code> event handler, <code>startup()</code>, is called:</p>

<pre class="brush: js notranslate">function startup() {
  colorWell = document.querySelector("#colorWell");
  colorWell.value = defaultColor;
  colorWell.addEventListener("input", updateFirst, false);
  colorWell.addEventListener("change", updateAll, false);
  colorWell.select();
}
</pre>

<p>This gets a reference to the color <code>&lt;input&gt;</code> element in a variable called <code>colorWell</code>, then sets the color input's value to the value in <code>defaultColor</code>. Then the color input's {{domxref("HTMLElement/input_event", "input")}} event is set up to call our <code>updateFirst()</code> function, and the {{domxref("HTMLElement/change_event", "change")}} event is set to call <code>updateAll()</code>. These are both seen below.</p>

<p>Finally, we call {{domxref("HTMLInputElement.select", "select()")}} to select the text content of the color input if the control is implemented as a text field (this has no effect if a color picker interface is provided instead).</p>

<h4 id="Reacting_to_color_changes">Reacting to color changes</h4>

<p>We provide two functions that deal with color changes. The <code>updateFirst()</code> function is called in response to the <code>input</code> event. It changes the color of the first paragraph element in the document to match the new value of the color input. Since <code>input</code> events are fired every time an adjustment is made to the value (for example, if the brightness of the color is increased), these will happen repeatedly as the color picker is used.</p>

<pre class="brush: js notranslate">function updateFirst(event) {
  var p = document.querySelector("p");

  if (p) {
    p.style.color = event.target.value;
  }
}</pre>

<p>When the color picker is dismissed, indicating that the value will not be changing again (unless the user re-opens the color picker), a <code>change</code> event is sent to the element. We handle that event using the <code>updateAll()</code> function, using {{domxref("HTMLInputElement.value", "Event.target.value")}} to obtain the final selected color:</p>

<pre class="brush: js notranslate">function updateAll(event) {
  document.querySelectorAll("p").forEach(function(p) {
    p.style.color = event.target.value;
  });
}
</pre>

<p>This sets the color of every {{HTMLElement("p")}} block so that its {{cssxref("color")}} attribute matches the current value of the color input, which is referred to using {{domxref("Event.target", "event.target")}}.</p>

<h3 id="Result">Result</h3>

<p>The final result looks like this:</p>

<p>{{EmbedLiveSample("Example", 700, 200)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#color-state-(type=color)')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Initial definition</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', 'forms.html#the-input-element')}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a class="external" href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("html.elements.input.input-color")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Learn/Forms/Property_compatibility_table_for_form_controls">Compatibility of CSS properties</a></li>
</ul>
